module GoTransverseTractApi

  module Service

    class ServiceDeviceInventoryItem

      class << self

        #
        # @param {Long} eid
        # @param {Hash} options
        #
        def find_by_eid eid, options={}
          return nil unless eid.present?

          params ||= GoTransverseTractApi::ApiData.new.get_query_params({eid: eid}, options)
          GoTransverseTractApi.get_response_for(self, params)
        end

        #
        # @param {Long} product_eid
        # @param {Hash} options
        #
        def find_by_product_eid product_eid, options={}
          return nil unless product_eid.present?

          params ||= GoTransverseTractApi::ApiData.new.get_query_params({product_eid: product_eid}, options)
          GoTransverseTractApi.get_response_for(self, params)
        end

        #
        # @param {String} status
        # @param {Hash} options
        #
        def find_by_status status, options={}
          return nil unless status.present?

          params ||= GoTransverseTractApi::ApiData.new.get_query_params({status: status}, options)
          GoTransverseTractApi.get_response_for(self, params)
        end

        #
        # @param {Long} serial_number
        # @param {Hash} options
        #
        def self.find_by_serial_number serial_number, options={}
          return nil unless serial_number.present?

          params ||= GoTransverseTractApi::ApiData.new.get_query_params({serial_number: serial_number}, options)
          GoTransverseTractApi.get_response_for(self, params)
        end

      end

    end

  end

end
